<template>
  <div class="wrapper" style="overflow-y: scroll;">

    <div class="header" style="position: sticky; top: 0; z-index: 5;">

      <router-link :to="{ name: 'choose-address' }">
        <div
          :style="`background-image: url(${require('@/assets/img/arrow-back.svg')})`"
          class="arrow-back-button"
        ></div>
      </router-link>
      
      Добавить адрес
    </div>


    <div v-if="$store.state.tips.addAddress" class="tip">
      Добавьте адрес доставки, чтобы найти ближайший магазин

      <div 
        @click="$store.commit('SET_TIP_STATUS', { tip: 'addAddress', status: false })" 
        :style="`background-image: url(${require('@/assets/img/cross.svg')})`" 
        class="cross-icon"
      ></div>
    </div>

    <div class="input-wrapper">
      <input
        class="input"
        type="text"
        placeholder="Адрес и дом"
        v-model="address"
        @input="findAddress()"
      />
    </div>

    <div v-if="!hideApartment" class="input-wrapper">
      <input
        class="input"
        type="text"
        placeholder="Номер квартиры"
        v-model="apartment"
      />
    </div>

    <div 
      style="padding: 20px; background-color: #fbf1f0;"
      @click="selectedAddress = addr; address = addr.address; hideApartment = false; geocoderAddrRes = []" 
      v-for="(addr, index) in geocoderAddrRes" 
      :key="index"
    >
      {{ addr.address }}
    </div>

    <div @click="mainButtonHandler($event)" class="save-button">
      Сохранить адрес
    </div>

    <router-link :to="{ name: 'choose-address' }">
      <div class="cancel">
        Отменить
      </div>
    </router-link>

  </div>
</template>

<script>
import {createRipple} from "@/utils/animations.js";
import { debounce } from "debounce";

export default {
  data() {
    return {
      address: '',
      apartment: '',
      geocoderAddrRes: [],
      selectedAddress: {},
      nothingFound: false,

      hideApartment: false,
    }
  },

  methods: {
    createRipple,

    findAddress: debounce(function() {
      if (this.address) {
        this.requestGeocoderByAddress(`Казахстан, ${this.address}`);
      }
    }, 1500),

    convertComponents(components) {
      let obj = {};
      for (let i = 0; i < components.length; i++) {
        let values = Object.values(components[i]);
        obj[values[0]] = values[1];
      }

      return obj;
    },

    returnAddrComponent(component) {
      if (Object.prototype.hasOwnProperty.call(this.selectedAddress.components, component)) {
        return this.selectedAddress.components[component];
      } else {
        return undefined;
      }
    },

    async mainButtonHandler(event) {
      this.createRipple(event); 
      if (!this.address) return;
      if (Object.keys(this.selectedAddress).length === 0) return;

      const body = {
        country: this.returnAddrComponent('country'),
        city: this.returnAddrComponent('locality'),
        street: this.returnAddrComponent('street'),
        house: this.returnAddrComponent('house'),
        // apartment: this.apartment,
        latitude: this.selectedAddress.coords[0],
        longitude: this.selectedAddress.coords[1],
        description: this.selectedAddress.description,
        name: this.selectedAddress.name + ', ' + this.apartment
      };

      this.$store.dispatch('SEND_ADDRESS', { data: body });
      
      this.$router.push({ name: 'choose-address' });
    },

    async requestGeocoderByAddress(address) {
      if (address === '' || address === '0') return;

      this.geocoderAddrRes = [];

      try {
        const request = await fetch(`https://geocode-maps.yandex.ru/1.x/?apikey=fb1dce8d-77c2-4f49-95f0-a8db651a3f8a&format=json&geocode=${address}&bbox=50.058051,55.174291~86.374889,40.533252&results=3&rspn=1`);
        let json = await request.json();
        let resLength = json.response.GeoObjectCollection.featureMember.length;


        if (resLength !== 0) {
          this.hideApartment = true;
          for (let i = 0; i < resLength; i++) {
            this.nothingFound = false;
            let address = json.response.GeoObjectCollection.featureMember[i].GeoObject.metaDataProperty.GeocoderMetaData.text;
            if (!(/Казахстан/.test(address))) continue;
            let formattedAddress = address.replace(/(,\s)*Казахстан(,\s)*/, '').replace(/улица /, 'ул. ').replace(/город /, 'г. ').replace(/Акмолинская область/, 'Акм. обл.').replace(/район/, 'р-н');
            let components = json.response.GeoObjectCollection.featureMember[i].GeoObject.metaDataProperty.GeocoderMetaData.Address.Components;

            let coords = json.response.GeoObjectCollection.featureMember[i].GeoObject.Point.pos.split(' ');
            let obj = {};
            obj.address = formattedAddress;
            obj.coords = [coords[1], coords[0]];
            obj.name = json.response.GeoObjectCollection.featureMember[i].GeoObject.name;
            obj.description = json.response.GeoObjectCollection.featureMember[i].GeoObject.description;
            obj.components = this.convertComponents(components);
            this.geocoderAddrRes.push(obj);
          }
          console.log(this.geocoderAddrRes);

        } else {
          this.nothingFound = true;
        }
      } catch (e) {
        console.log(e);
      }
    },
  }
}
</script>

<style scoped>
@import '../styles/styles.css';
</style>